#ifndef __GLCAMERA_H
#define __GLCAMERA_H

#include <iostream>
#include <SDL.h>
#include <SDL_opengl.h>
#include "rotationsmatrix.h"
#include "emath_opengl.h"
#include "punkt3d.h"

class GLCamera {
	private:
		Punkt3D std_dir;
		Punkt3D std_norm;
	
		Punkt3D pos;
		Punkt3D norm;
		Punkt3D dir;		// normalisiert
		
		float rotx;
		float roty;
		bool doupdate;
		
		float mpersec;
		float apersec;
		
		Rotationsmatrix rotmatX;
		Rotationsmatrix rotmatY;
		
		void updateVectors();
	public:
		GLCamera();
// 		GLCamera(Punkt3d
		
		void setCamera();
		void setPosDirNorm(Punkt3D p, Punkt3D D, Punkt3D n);
		
		// Std Move
		void moveForward(float sec);
		void moveBackward(float sec);
		void moveLeft(float sec);
		void moveRight(float sec);
		void rotateLeft(float sec);
		void rotateRight(float sec);
		void rotateUp(float sec);
		void rotateDown(float sec);
		
		void handleKeys(float sec);
		
		float getXrot();
		float getYrot();
		
		void print();
		void renderCoord();
		Punkt3D getPos();
		
		~GLCamera();
};

#endif
