#include "glcolor.h"

GLColor::GLColor() {
	set(0.0f, 0.0f, 0.0f, 1.0f);
	setalpha = true;
}

GLColor::GLColor(float _r, float _g, float _b, float _a) {
	set(_r, _g, _b, _a);
}

GLColor::GLColor(const SDL_Color &c) {
	set(c.r/255.0f, c.g/255.0f, c.b/255.0f);
	setalpha = true;
}

void GLColor::set(float _r, float _g, float _b, float _a) {
	r = _r;
	g = _g;
	b = _b;
	a = _a;
}

SDL_Color GLColor::getSDLColor() {
	SDL_Color c = {(Uint8)(r*255.0f), (Uint8)(g*255), (Uint8)(b*255), (Uint8)(a*255)};
	return c;
}

void GLColor::print(std::string m) {
	std::cout << m << " Color: " << r << ", " << g << ", " << b << std::endl;
}

void glColorGLC(GLColor c) {
	if(c.setalpha) {
		glColor4f(c.r, c.g, c.b, c.a);
	} else {
		glColor3f(c.r, c.g, c.b);
	}	
}
