#ifndef __GLGUIWINDOW_H
#define __GLGUIWINDOW_H

#include <iostream>
#include <string>
#include <vector>
#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>

#include "../glcolor.h"
#include "../gldrawhelper.h"
#include "object.h"


class GLGuiWindow : public GLGuiObject {
	private:
		bool renderbackground;
		SDL_Rect pos;
		GLColor bgcolor;
		
		std::vector<GLGuiObject*> items;
		
		std::vector<GLGuiObject*> highlightable;
		std::vector<GLGuiObject*> clickable;
		std::vector<GLGuiObject*> keyboardable;
	public:
		GLGuiWindow(SDL_Rect _pos, GLColor _bgcolor);
		~GLGuiWindow();
		
		void addItem(GLGuiObject*);
		SDL_Rect getPos();
		void render();
};

#endif
