#ifndef __MENUMENU_H
#define __MENUMENU_H

#include <vector>
#include <SDL.h>
#include "../punkt2d.h"
#include "menuitem.h"

class MenuMenu {
	private:
		std::vector<MenuItem*> menuitems;
		
		int itempos;
		Punkt2D menupos;
		bool centermenu;
		bool centerScreenX;
		bool dohighlight;
		bool paintbackground;
		int basefontsize;
		int offset;
		int maxwidth;
		int valuewidth;
		GLFontEngine fontengine;
		
		// Soll anderes center evtl. ersetzen
		// TODO: cleanup
		bool fullcenter;
	public:
		MenuMenu();
		
		void setPos(const Punkt2D&);
		void setCenter(bool);
		void setCenterScreenX(bool);
		void setBaseFontSize(int);
		void setMaxWidth(int);
		void setPaintBackground(bool);
		
		void up();
		void down();
		void left();
		void right();
		void select();
		void charInput(char c);
		
		void resetItemPos();
		
		
		void addMenuItem(MenuItem*);
		void render();
};

#endif
