#ifndef __QUATERNION_H
#define __QUATERNION_H

#include <iostream>
#include <cmath>
#include <SDL_opengl.h>
// #include "rotationsmatrix.h"
#include "punkt3d.h"
#include "emath.h"

class Quaternion {
	private:
		float x, y, z, w;
	
	public:
		Quaternion();
		Quaternion(float _x, float _y, float _z, float _w);
		Quaternion(float deg, Punkt3D p);
		Quaternion(float _x, float _y, float _z);
		
		void set(float rotx, float roty, float rotz);
		void set(float deg, Punkt3D axis);
		void normalize();
		Quaternion getConjugate();
// 		Rotationsmatrix getRotMat();
		Punkt3D rotP3D(const Punkt3D &p);
		
		Quaternion operator*(const Quaternion&);
};




// class Quaternion {
// 	private:
// 		float w;
// 		float x,y,z;
// 	public:
// 		Quaternion();
// 		void createFromRotation(float, float, float, float);
// 		
// 
// 		void createGlMatrix(GLfloat*);
// 		Punkt3D getDirectionVector();
// 		Punkt3D getDirectionVector(GLfloat*);
// 		
// 		Quaternion operator*(const Quaternion&);
// 		
// 
// };
// 
// void glMultMatrixf(Quaternion);

#endif
